program UrejenSeznam;
{
****************************************************************************
zadnja sprememba: 25.1.2001

Avtor: Suzana Magdevska univ. dipl. ing.
****************************************************************************
Program je pripomocek za lazje razumevanje zgledov in vaj, ki sem jih
pripravila v prirocniku za KAZALCE v PASCALU. Razlaga podprogramov najdete
v dokumentu KAZALCI.DOC (dokument je zapisan v formatu Win WORD 8.0 iz
paketa Microsoft OFFICE 97).


Zaradi lepsega videza na ekranu sem uporabila neke funkcije,
ki jih podpira turbo pascal:
clrscr
keypressed}
uses crt;
type    kazal=^vozel;
	vozel= record
		   stevilo: integer;
                   strazar:boolean;
		   naslednji: kazal
		end;

var ZacetekSeznama: kazal;

procedure Init(var p:kazal);
begin
  new(p);
  p^.naslednji:=nil;
  p^.strazar:=true
end;{init}

procedure SprostiPomnilnik(var p:kazal);
{procedura sprosti spomin in postavi klicani kazalec na vrednost nil}
begin
  if p<>nil then
  begin
    SprostiPomnilnik(p^.naslednji);
    Dispose(p)
  end;
  p:=nil
end; {SprostiPomnilnik}

function NaselRekurzivno(element:integer;p:kazal):boolean;
{parameter element je iskano stevilo, p je kazalec na seznam}
begin
  if p^.strazar then NaselRekurzivno:=false
  else
    if p^.stevilo=element then NaselRekurzivno:=true
    else NaselRekurzivno:=NaselRekurzivno(element,p^.naslednji)
end; {NaselRekurzivno}

function NaselIterativno(element:integer;p:kazal):boolean;
{parameter element je iskano stevilo, p je kazalec na seznam}
var najden:boolean;
begin
  najden:=false;
  while ((not p^.strazar) and (not najden)) do
   if p^.stevilo=element then najden:=true
   else p:=p^.naslednji;

  NaselIterativno:=najden
end;{NaselIterativno}

procedure PobrisiElement(var p:kazal;i:integer);
{procedura poisce in pobrise element i iz seznama}
var tmpKazalec:kazal;
begin
  if ((not p^.strazar) and (p^.stevilo<=i))  then
  begin
    PobrisiElement(P^.naslednji,i);
    if i=p^.stevilo then
    begin
      tmpKazalec:=p;
      p:=p^.naslednji;
      dispose(tmpKazalec)
    end
  end
end;{PobrisiElement}

procedure PobrisiDvojne(var p:kazal);
{procedura pobrise dvojne elemente v seznamu}
var tmpKazalec:kazal;
begin
  if not p^.strazar  then
  begin
    PobrisiDvojne(P^.naslednji);
    if NaselIterativno(p^.stevilo,p^.naslednji) then
    begin
      tmpKazalec:=p;
      p:=p^.naslednji;
      dispose(tmpKazalec)
    end
  end
end;{PobrisiDvojne}

procedure Vstavi(var p:kazal; element:integer);
{ procedura vstavi element v urejeni seznam}
var q:kazal;
begin
  if ((p^.strazar) or (p^.stevilo>=element)) then
   begin
    new(q);
    q^:=p^;
    p^.stevilo:=element;
    p^.strazar:=false;
    p^.naslednji:=q;
   end
  else  Vstavi(p^.naslednji,element)
end;{Vstavi}

procedure Izpisi_Seznam_Kazalci;
{izpis vseh elementov seznama, razen strazarja}
var p: kazal;
begin
  p:=zacetekSeznama;
  while not p^.strazar do
  begin
    write(p^.stevilo:5);
    p:=p^.naslednji
  end
end;{Izpisi_Seznam_Kazalci}

procedure Izpisi_Seznam_Obratno(p:kazal);
{izpis vseh elementov seznama v obratnem vrstnem redu, razen strazarja}
begin
  if not p^.strazar then
  begin
     Izpisi_Seznam_Obratno(p^.naslednji);
     write(p^.stevilo:5)
  end
end;{Izpisi_Seznam_Obratno}

procedure Generiranje_Nakljucnih_Stevil(j:integer);
{procedura generira 100 nakljucnih stevil od 1 do 1000 in jih vstavi v seznam}
var p: kazal;
    i:integer;
begin
  randomize;
  for i:=1 to j do
     Vstavi(ZacetekSeznama,random(1000)+1)
end;{Generiranje_Nakljucnih_Stevil}


procedure Menu;
  procedure pavza;
  {procedura ustavi delovanje programa, dokler uporabnik ne pritisne
   neko tipko na tipkovnici}
  begin
   repeat until keypressed
  end; {pavza}

  procedure PostaviIzbireNaZaslon;
  begin
    clrscr;
    writeln('1: Izbrisi vse elemente seznama');
    writeln('2: Nakljucno generiraj stevila');
    writeln('3: Vstavi element v seznam');
    writeln('4: Najdi element');
    writeln('5: Pobrisi dvojne');
    writeln('6: Pobrisi element');
    writeln('7: Izpisi seznam');
    writeln('8: Izpisi seznam padajoce');
    writeln('Esc: Konec ')
  end;{PostaviIzbireNaZaslon}

var ch:char;
    i:integer;
begin {zacetek Menu}
   repeat
        PostaviIzbireNaZaslon;
        ch:=readkey;
        case ch of
        '1': begin SprostiPomnilnik(ZacetekSeznama); 
                   Init(ZacetekSeznama) 
             end;
        '2': begin clrscr; write('Koliko stevil? '); readln(i);
                   Generiranje_Nakljucnih_Stevil(i)
             end;
        '3': begin clrscr; write('Vstavim element:');readln(i);
                   Vstavi(ZacetekSeznama,i)
             end;
        '4': begin clrscr; write('Najdem element:');readln(i);
                   if NaselIterativno(i,ZacetekSeznama) then writeln('Ta element je v seznamu')
                   else writeln('ta element ni v seznamu');
                   pavza
             end;
        '5': PobrisiDvojne(ZacetekSeznama);
        '6': begin
              clrscr; write('Pobrisem element:');readln(i);
              PobrisiElement(ZacetekSeznama,i)
             end;
        '7':begin Izpisi_Seznam_Kazalci; pavza end;
        '8':begin Izpisi_Seznam_Obratno(ZacetekSeznama); pavza end;
        end; {case}
   until ord(ch)=27;
{koda 27 je Esc}
end;{Menu}

begin {glavni program}
  Init(ZacetekSeznama);
  Menu;
  SprostiPomnilnik(zacetekSeznama)
end.{glavni program}